e_shopper_laravel/routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//frontend
Route::get('/', [App\Http\Controllers\frontend\HomeController::class, 'index']);

// backend
Route::get('/home', function () {
    return view('admin.dashboard');
});

Auth::routes();

Route::prefix('/admin')->group(function (){
    Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('admin');
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
    Route::get('/logout', [App\Http\Controllers\HomeController::class, 'logout'])->name('logout');
    Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

    Route::get('/profile', [App\Http\Controllers\admin\UserController::class, 'index'])->name('profile');
    Route::post('/profile', [App\Http\Controllers\admin\UserController::class, 'update']);


    Route::get('/blog', [App\Http\Controllers\admin\BlogController::class, 'index'])->name('admin.blogs');
    Route::get('/blog/create', [App\Http\Controllers\admin\BlogController::class, 'create'])->name('admin.blog-create');
    Route::post('/blog/create', [App\Http\Controllers\admin\BlogController::class, 'store']);
    Route::get('/blog/edit/{id}', [App\Http\Controllers\admin\BlogController::class, 'edit'])->name('admin.blog-edit');
    Route::post('/blog/edit/{id}', [App\Http\Controllers\admin\BlogController::class, 'update']);
    Route::get('/blog/destroy/{id}', [App\Http\Controllers\admin\BlogController::class, 'destroy'])->name('admin.blog-destroy');


    Route::get('/category', [App\Http\Controllers\admin\categoryController::class, 'index'])->name('admin.categories');
    Route::get('/category/create', [App\Http\Controllers\admin\categoryController::class, 'create'])->name('admin.category-create');
    Route::post('/category/create', [App\Http\Controllers\admin\categoryController::class, 'store']);
    Route::get('/category/edit/{id}', [App\Http\Controllers\admin\categoryController::class, 'edit'])->name('admin.category-edit');
    Route::post('/category/edit/{id}', [App\Http\Controllers\admin\categoryController::class, 'update']);
    Route::get('/category/destroy/{id}', [App\Http\Controllers\admin\categoryController::class, 'destroy'])->name('admin.category-destroy');


    Route::resource('attributes',App\Http\Controllers\admin\AttributeController::class);
    Route::resource('product',App\Http\Controllers\admin\ProductController::class);

    Route::get('/product', [App\Http\Controllers\admin\ProductController::class, 'index'])->name('product.index');
    Route::get('/product/create', [App\Http\Controllers\admin\ProductController::class, 'create'])->name('product.create');
    Route::post('/product/create', [App\Http\Controllers\admin\ProductController::class, 'store']);
    Route::get('/product/edit/{id}', [App\Http\Controllers\admin\ProductController::class, 'edit'])->name('product.edit');
    Route::get('/product/show/{id}', [App\Http\Controllers\admin\ProductController::class, 'show'])->name('product.show'); 
    Route::post('/product/update/{id}', [App\Http\Controllers\admin\ProductController::class, 'update'])->name('product.update');
    Route::get('/product/destroy/{id}', [App\Http\Controllers\admin\ProductController::class, 'destroy'])->name('product.destroy');

    //Product attributes 
    Route::get('/product/show/attr/create/{id}', [App\Http\Controllers\admin\ProductAttributeController::class, 'create'])->name('product-attr.create');
    Route::post('/product/show/attr/create/{id}', [App\Http\Controllers\admin\ProductAttributeController::class, 'create']);
    Route::get('/product/show/attr/edit/{id}', [App\Http\Controllers\admin\ProductAttributeController::class, 'edit'])->name('product-attr.edit');
    Route::post('/product/show/attr/update/{id}', [App\Http\Controllers\admin\ProductAttributeController::class, 'update'])->name('product-attr.update');
    Route::get('/product/show/attr/destroy/{id}', [App\Http\Controllers\admin\ProductAttributeController::class, 'destroy'])->name('product-attr.destroy');
});

e_shopper_laravel/app/Models/Product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

use function PHPUnit\Framework\isNull;

class Product extends Model
{
    use HasFactory;
    protected $table = 'tbl_product';
    protected $fillable = [
        'id_product',
        'id_category',
        'product_name',
        'product_des',
        'product_image',
        'product_price',
        'product_content',
        'product_status',
        'created_at',
        'updated_at'
    ];
    protected $primary_key ='id';

    protected $hidden = [
        '_token',
        'product_image',
    ];

    public $timestamps = false;
}

e_shopper_laravel/app/Http/Controllers/admin/ProductController.php
<?php

namespace App\Http\Controllers\admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\ProductRequest;
use App\Models\Attribute;
use App\Models\Category;
use App\Models\Product;
use App\Models\ProductAttr;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Image;

class ProductController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');   
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $product =Product::all();
        $attr = Attribute::all();
        $product_attr =ProductAttr::all();
        $category = Category::all();
        
        return view('admin.products.list')->with(compact('product','product_attr','attr','category'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $list = Category::all();
        $parent_category = Category::where('category_level',0)->get();
        $color_list = Attribute::where('attr_name',"color")->get();
        $size_list = Attribute::where('attr_name',"size")->get();
        return view('admin.products.add')->with(compact('list','parent_category','color_list','size_list'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ProductRequest $request)
    {
        $errors = 0;
        $id_product = $request->id_product;
        if($request->hasfile('product_image'))
        {
            foreach($request->file('product_image') as $image)
            {
                    $name = $id_product.'-'.$image->getClientOriginalName();
                $file_images[] = $name;
            }
        }
        $product_attr_qty = $request->product_attr_qty;
        $product_attr_price = $request->product_attr_price;

        $product_info = [
            'product_image' => json_encode($file_images),
            'id_product' => $request->id_product,
            'id_category' => $request->id_category,
            'product_name' => $request->product_name,
            'product_status' => $request->product_status,
            'product_price' => $request->product_price,
            'product_des' => $request->product_des,
            'product_content' => $request->product_content,
            'created_at' => now(),
        ];
        $product = Product::create($product_info);
        if ($product) {
            if($request->hasfile('product_image'))
            {
                foreach($request->file('product_image') as $image)
                {

                    $name = $product->id_product.'-'.$image->getClientOriginalName();
                    //$image->move('upload/product/', $name);
                    $path = public_path('backend/upload/products/' . $name);
                    Image::make($image->getRealPath())->save($path);
                    // $file_images[] = $name;
                }
            }
            
            foreach ($request->product_attr_name as $key => $value) {
                $product_attr = [
                    'product_id' => $product->id_product,
                    'product_attr_name' =>  $value,
                    'product_attr_qty' => $product_attr_qty[$key],
                    'product_attr_price' => $product_attr_price[$key],
                    'product_attr_status' => 1,
                ];
                $product_attr = ProductAttr::create($product_attr);
                if ($product_attr == false) {
                    $errors = 1;
                }
            }
            
        }
        if ($errors == 0) {
            $msg = "Add product success!";
            $style = "success";
        }else{
            $msg = "Add product errors!";
            $style = "danger";
        }
        // dd($product);

        return redirect()->back()->with(compact('msg','style'));
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $list = Category::all();
        $parent_category = Category::where('category_level',0)->get();
        $color_list = Attribute::where('attr_name',"color")->get();
        $size_list = Attribute::where('attr_name',"size")->get();
        $product = Product::find($id);
        $product_info = ProductAttr::where('product_id',$product->id_product)->get();
        return view('admin.products.show_info')->with(compact('list','parent_category','color_list','size_list','product','product_info'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $product = Product::find($id);
        $get_name_category = Category::where('id',$product->id_category)->first();
        $parent_category = Category::where('category_level',0)->get();
        $list = Category::all();


        return view('admin.products.edit')->with(compact('product','list','parent_category','get_name_category'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $data = $request->all();
        $product = Product::find($id);
        $images_delete = $request->image_delete;  
        // dd($images_delete);

        $image_old =json_decode($product->product_image);
        if (!empty($images_delete)) {
            foreach ($image_old as $key => $value) {
                if (in_array($value,$images_delete)) {
                 unset($image_old[$key]);
                }
             }
        }
        
        $image_new = $image_old;

        //hinh them
        if($request->hasfile('product_image'))
        {
            foreach($request->file('product_image') as $image)
            {
                $name = $product->id_product.'-'.$image->getClientOriginalName();
                $file_images[] = $name;
            }
            $image_new = array_merge($file_images ,$image_old);
        }

        if (count($image_new)<=5 && count($image_new)> 0) {
            $data['product_image']=json_encode($image_new);
            // dd($data);
            if ($product->update($data)) {
                if($request->hasfile('product_image'))
                {
                    foreach($request->file('product_image') as $image)
                    {

                        $name =$product->id_product.'-'.$image->getClientOriginalName();
                        //$image->move('upload/product/', $name);
                        $path = public_path('backend/upload/products/'.$name);

                        Image::make($image->getRealPath())->save($path);
                        
                    }
                    if (!empty($images_delete)) {
                        foreach ($images_delete as $key => $value) 
                        {
                             unlink('backend/upload/products/'.$value);
                        }
                    }
                }
                $msg = 'Update product success!';
                $style = 'success';
            }else{
                $msg = 'Update product errors!';
                $style = 'danger';

            }
        }
        else{
            $msg = 'images errors';
            $style = 'danger';

        }
        return redirect()->back()->with(compact('msg','style'));

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request,$id)
    {
        $product =Product::find($id);
        if ($product) {
            $product_attr = ProductAttr::where('product_id',$product->id_product)->get();
            if ($product_attr) {
                $product_attr->delete();
            }
            $product->delete();
            $msg = 'delete all product success';
            $style = 'success';
        }else{
            $msg = 'delete errors';
            $style = 'danger';
        }
        return redirect()->back()->with(compact('msg','style'));
    }

}

e_shopper_laravel/resources/views/admin/products/add.blade.php
@extends('admin.layouts.app')
@section('content')
	<section class="wrapper">
        @if (session('msg'))
            <div class="alert alert-{{session('style')}}">
                {{ session('msg') }}
            </div>
      @endif
		<div class="row">
            <div class="col-lg-12">
                <section class="panel">
                    <header class="panel-heading">
                        Create Blog
                        <span class="tools pull-right">
                            <a class="fa fa-chevron-down" href="javascript:;"></a>
                            <a class="fa fa-cog" href="javascript:;"></a>
                            <a class="fa fa-times" href="javascript:;"></a>
                         </span>
                    </header>
                    <div class="panel-body">
                        <form class="form-horizontal form-material" enctype="multipart/form-data" method="POST" action="{{ route('product.store') }}">
                            @csrf
                            <div class="form-group">
                                <label class="col-md-12">product Id <span style="color: red">(*)</span></label>
                                <div class="col-md-12">
                                    <input type="text" class="form-control form-control-line" id="product_id" name="id_product" value="">
                                    @error('product_id')
                                    <span style="color: red">{{ $message }}</span>
                                    @enderror
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-md-12">product Name <span style="color: red">(*)</span></label>
                                <div class="col-md-12">
                                    <input type="text" class="form-control form-control-line" name="product_name" value="">
                                    @error('product_name')
                                    <span style="color: red">{{ $message }}</span>
                                    @enderror
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-md-12">Product Image</label>
                                <div class="col-md-12">
                                    <input type="file" class="form-control form-control-line" name="product_image[]" multiple="multiple">
                                    @error('product_image')
                                    <span style="color: red">{{ $message }}</span>
                                    @enderror
                                </div>
                            </div>

                            <div class="form-group">
                                <label class="col-md-12">product Price <span style="color: red">(*)</span></label>
                                <div class="col-md-12">
                                    <input type="text" class="form-control form-control-line" name="product_price" value="">
                                    @error('product_price')
                                    <span style="color: red">{{ $message }}</span>
                                    @enderror
                                </div>
                            </div>

                            <div class="form-group">
                                <label for="example-email" class="col-md-12">Descriptions</label>
                                <div class="col-md-12">
                                    <textarea rows="5" class="form-control form-control-line"  name="product_des"></textarea>
                                    @error('product_content')
                                    <span style="color: red">{{ $message }}</span>
                                    @enderror
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="example-email" class="col-md-12">Content</label>
                                <div class="col-md-12">
                                    <textarea rows="5" class="form-control form-control-line"  name="product_content"></textarea>
                                    @error('product_des')
                                    <span style="color: red">{{ $message }}</span>
                                    @enderror
                                </div>
                            </div>
                            <div class="form-group">
                                <label class="col-sm-12">Status</label>
                                <div class="col-sm-6">
                                    <div class="custom-control custom-radio">
                                        <input type="radio" id="customRadio1" name="product_status" class="custom-control-input" value="0">
                                        <label class="custom-control-label" for="customRadio1">Hide</label>

                                        <input type="radio" id="customRadio2" name="product_status" class="custom-control-input" value="1">
                                        <label class="custom-control-label" for="customRadio2">Show</label>
                                    </div>
                                </div>

                            </div>
                            <div class="form-group">
                                <label class="col-sm-12">Size</label>
                                    @foreach ($size_list as $value)
                                    <div class="col-sm-1">
                                        <div class="custom-control custom-checkbox checkbox_size">
                                            <input type="checkbox" class="custom-control-input product_size" name="product_size[]" id="customCheck{{ $value->id }}" value="{{ $value->attr_value }}">
                                            <label class="custom-control-label" for="customCheck{{ $value->id }}">{{ $value->attr_value }}</label>
                                        </div>
                                    </div>
                                    @endforeach
                                    @error('product_size')
                                        <span style="color: red">{{ $message }}</span>
                                    @enderror
                            </div>
                            <div class="form-group">
                                <label class="col-sm-12">Color</label>
                                    @foreach ($color_list as $value)
                                    <div class="col-sm-1">
                                        <div class="custom-control custom-checkbox ">
                                            <input type="checkbox" class="custom-control-input product_color" name="product_color[]" id="colorcustomCheck{{ $value->id }}" value="{{ $value->attr_value }}">
                                            <label class="custom-control-label" for="colorcustomCheck{{ $value->id }}">{{ $value->attr_value }}</label>
                                        </div>
                                    </div>
                                    @endforeach
                                    @error('product_size')
                                        <span style="color: red">{{ $message }}</span>
                                    @enderror
                            </div>
                            
                            <div class="form-group">
                                <label class="col-sm-12">Category</label>
                                <div class="col-sm-12">
                                    <select class="form-control form-control-line" name="id_category">
                                        <option  value="0" selected>category</option>
                                        @foreach ($parent_category as $parent_value )
                                            <option  value="{{ $parent_value->id  }}">--{{$parent_value->category_name}}--</option>
                                            @foreach ($list as $value_item)
                                                @if ($value_item->category_level == $parent_value->id)
                                                    <option  value="{{ $value_item->id  }}">----{{$value_item->category_name}}----</option>
                                                @endif
                                            @endforeach
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="col-sm-12">
                                    <a  class="btn btn-success send_data">Create product</a>
                                </div>
                            </div>

                            <div class="table-responsive" id="list_product_attr">
                            </div>
                        </form>
                    </div>
                </section>
            </div>
        </div>
        
    <div class="clearfix"> </div>
    <script>
        $(document).ready(function () {
            var rs = [];
            var color =[];
            var size =[];
            var html = '';
            $('.send_data').click(function(){
                rs = [];
                color =[];
                size =[];
                html = "<table class='table'>"+
                            "<thead>"+
                                "<tr>"+
                                    "<th scope='col'>ID_Product</th>"+
                                    "<th scope='col'>Product_attr</th>"+
                                    "<th scope='col'>Qty</th>"+
                                    "<th scope='col'>Price</th>"+
                                "</tr>"+
                            "</thead>"+
                            "<tbody>";
        
        
                var product_id = $("#product_id").val();
                var j = 0;
                $(':checkbox:checked').map(function (i) {
                    rs[i]=$(this).val();
                    if ($(this).hasClass('product_size')) {
                        size[i] =$(this).val();
                    }else{
                        color[j] =$(this).val();
                        j++;
                    };
                });
        
                size.forEach(color_val => {
                    color.forEach(size_val => {
                        // console.log(color_val +'-'+ size_val); 
                        html+="<tr>"+
                                "<th scope='row' class='product_attr_id'>"+product_id+"</th>"+
                                "<th><input type='text' class='product_attr_name product_attr' name='product_attr_name[]' value ='"+color_val +"-"+ size_val+"'></th>"+
                                "<th><input type='text' class='product_attr_qty product_attr' name='product_attr_qty[]'></th>"+
                                "<th><input type='text'  class='product_attr_price product_attr' name='product_attr_price[]'></th>"+
                                "<input type='hidden'  class='product_attr_price product_attr' name='data_attr[]' value = '"+product_id+"','"+product_id+"'>"+
                            "</tr>";
                        });
                    });
        
                html+="</tbody>"+
                        "</table>"+
                    "<div class='form-group'>"+
                        "<div class='col-sm-12'>"+
                            "<button type='submit'  class='btn btn-success'>Save Product</button>"+
                        "</div>"+
                    "</div>";
        
                    $("#list_product_attr").html(html);
        
                }); 
            });
        </script>
        <style>
            .product_attr{
                border: none;
                height: 40px;
                width: 100%;
                outline: none;
            }
        </style>
    </section>
@endsection

e_shopper_laravel/resources/views/admin/products/list.blade.php
@extends('admin.layouts.app')
@section('content')
	<section class="wrapper">
        @if (session('msg'))
					<div class="alert alert-{{session('style')}}">
						{{ session('msg') }}
					</div>
				@endif
		<div class="table-agile-info">
            <div class="panel panel-default">
                <div class="panel-heading">
                    Create Blog
                </div>
                <div class="row w3-res-tb">
                    <div class="col-sm-5 m-b-xs">
                        <select class="input-sm form-control w-sm inline v-middle">
                            <option value="0">Bulk action</option>
                            <option value="1">Delete selected</option>
                            <option value="2">Bulk edit</option>
                            <option value="3">Export</option>
                        </select>
                        <button class="btn btn-sm btn-default">Apply</button>                
                    </div>
                    <div class="col-sm-4">
                    </div>
                    <div class="col-sm-3">
                        <div class="input-group">
                            <input type="text" class="input-sm form-control" placeholder="Search">
                            <span class="input-group-btn">
                                <button class="btn btn-sm btn-default" type="button">Go!</button>
                            </span>
                        </div>
                    </div>
                </div>
                <div class="table-responsive">
                    <table class="table">
                        <thead>
                            <tr>
                                <th scope="col">Id</th>
                                <th scope="col">Name</th>
                                <th scope="col">Image</th>
                                <th scope="col">Category</th>
                                <th scope="col">Status</th>
                                <th scope="col">Action</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach ($product as $value )
                                @php
                                    $product_image = json_decode($value->product_image)
                                    $url_product_image = 'backend/upload/products/'.$product_image[0]
                                    
                                @endphp
                                <tr>
                                    <th scope="row">{{ $value->id_product }}</th>
                                    <th scope="row">{{ $value->product_name }}</th>
                                    <td><img src="{{ asset($url_product_image) }}" alt="" style="width: 100px;"></td>
                                    <td style="">
                                        @foreach ($category as $item_cate) 
                                            @if ($item_cate->id == $value->id_category) 
                                                {{ $item_cate->category_name }}
                                            @endif
                                        @endforeach
                                    </td>
                                    <td>
                                        @if ($value->product_status == 1)
                                            <a href="" class="alert-success"> Show</a>
                                        @else
                                            <a href="" class="alert-danger"> Hide</a>
                                        @endif
                                    </td>
                                    <td>
                                        <a href="{{ route('product.show',$value->id) }}">Details</a> |
                                        <a href="{{ route('product.destroy',$value->id) }}" id="delete-handel" class="active" ui-toggle-class=""><i class="fa fa-times text-danger text"></i></a>
                                    </td>
                                </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
                <div class="form-group">
                    <div class="col-sm-12">
                        <a href="{{ route('product.create') }}" class="btn btn-success">Add product</a>
                    </div>
                </div>
            </div>
        </div>
    </section>
   
@endsection